unit hud3dfrm;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_vgcore, dx_scene, dx_vglayer, dx_ani, dx_objects;

type
  TfrmHud3D = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    GuiLayer: TdxGUIObjectLayer;
    Root3: TvxLayout;
    HudWindow1: TvxHudWindow;
    HudButton1: TvxHudButton;
    HudButton2: TvxHudButton;
    HudButton4: TvxHudButton;
    HudButton3: TvxHudButton;
    HudButton5: TvxHudButton;
    Layout1: TvxLayout;
    procedure Root1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
    procedure HudButton1Click(Sender: TObject);
    procedure HudButton2Click(Sender: TObject);
    procedure HudButton3Click(Sender: TObject);
    procedure HudButton4Click(Sender: TObject);
    procedure HudButton5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmHud3D: TfrmHud3D;

implementation

{$R *.dfm}

procedure TfrmHud3D.Root1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
begin
  dxScene1.BeginResize;
end;

procedure TfrmHud3D.HudButton1Click(Sender: TObject);
begin
  Randomize;
  if GuiLayer.RotateAngle.Y <> 0 then
  begin
    GuiLayer.AnimateFloat('RotateAngle.Y', 0, 0.3);
    GuiLayer.AnimateFloatWait('Position.Z', 0, 0.3);
  end;
  { rotate }
  GuiLayer.AnimateFloat('Position.Z', 300, 0.3);
  GuiLayer.AnimateFloatWait('RotateAngle.X', 90, 0.3);
  { flip }
  GuiLayer.RotateAngle.X := 270;
  Hudwindow1.Fill.Color := vgColorToStr((vgStrToColor(Hudwindow1.Fill.Color) and $FF000000) or random($FFFFFF));
  { restore }
  GuiLayer.AnimateFloat('Position.Z', 0, 0.3);
  GuiLayer.AnimateFloat('RotateAngle.X', 360, 0.3);
end;

procedure TfrmHud3D.HudButton2Click(Sender: TObject);
begin
  ShowBrushDialog(Hudwindow1.Fill, [vgBrushSolid, vgBrushGradient, vgBrushBitmap], false);
end;

procedure TfrmHud3D.HudButton3Click(Sender: TObject);
begin
  GuiLayer.AnimateFloat('RotateAngle.Y', 20, 0.3);
  GuiLayer.AnimateFloat('Position.Z', 50, 0.3);
end;

procedure TfrmHud3D.HudButton4Click(Sender: TObject);
begin
  GuiLayer.AnimateFloat('RotateAngle.Y', -20, 0.3);
  GuiLayer.AnimateFloat('Position.Z', 50, 0.3);
end;

procedure TfrmHud3D.HudButton5Click(Sender: TObject);
begin
  GuiLayer.AnimateFloat('RotateAngle.Y', 0, 0.3);
  GuiLayer.AnimateFloat('Position.Z', 0, 0.3);
end;

end.
